

function editableTableAllowReordering(tableId)
{
    //in older versions, the param passed to the init function is actually the table not its id
    if (typeof(tableId) == 'object')
    {
        tableId = tableId.getAttribute('id');
    }

    if (hyf.editabletable.optionsCollection[tableId].allow_reorder)
    {
        var table = document.getElementById(tableId);
        var tbody = document.getElementById(tableId + '_body');
        var rows = tbody.rows;
        for (var i=0; i < rows.length; ++i)
        {
            var row = rows[i];
            var reorderTd = document.createElement('td');
            reorderTd.setAttribute('id', row.getAttribute('id') + "_reorder");
            row.appendChild(reorderTd);

            reorderTd.innerHTML = '<a class="editabletable_up_btn" href="javascript:editabletableMoveRow(\''+row.getAttribute('id')+'\', \'up\')" title="Move Up"><span>Up</span></a> ' +
                                  '<a class="editabletable_down_btn" href="javascript:editabletableMoveRow(\''+row.getAttribute('id')+'\', \'down\')" title="Move Down"><span>Down</span></a>';

            reorderTd.className = row.cells[0].className + ' ' + hyf.editabletable.classes.btnContainer;
        }


        var theadRow = table.tHead.rows[0];
        var lastHeader = theadRow.cells[theadRow.cells.length - 1];
        lastHeader.colSpan = lastHeader.colSpan + 1;

        var insertTd = document.getElementById(tableId + '_insert');
        if (insertTd)
        {
            insertTd.colSpan = insertTd.colSpan + 1;
        }
    }
}

dojo.connect(hyf.editabletable, 'initImpl', editableTableAllowReordering);



function editabletableMoveRow(rowId, dir)
{
    if (hyf.editabletable.currentRowId != null)
        hyf.editabletable.cancelChanges(hyf.editabletable.currentRowId);


    var targetRow = document.getElementById(rowId);

    var topRow = (dir == 'down') ? targetRow : hyf.util.getPreviousElementSibling(targetRow);
    var bottomRow = (dir == 'down') ? hyf.util.getNextElementSibling(targetRow) : targetRow;

    if ((topRow == null) || (bottomRow == null))
    {
        return;
    }

    var table = hyf.editabletable.findParentTable(targetRow)

    //adjust the HTML
    topRow.parentNode.insertBefore(bottomRow, topRow);

    //update the ids etc in each row accordingly
    for (var counter = 0; counter < 2; ++counter)
    {
        var rowToAdjust = (counter==0) ? topRow : bottomRow;


        //change IDs of all following rows to reduce repeat number part to prevent future conflicts
        var currentNum = hyf.editabletable.retrieveNumberFromId(rowToAdjust.getAttribute('id'), table.getAttribute('id'));
        var currentId = table.getAttribute('id') + currentNum;
        var newId;
        if (rowToAdjust == topRow)
            newId = table.getAttribute('id') + (parseInt(currentNum) + 1);
        else
            newId = table.getAttribute('id') + (parseInt(currentNum) - 1);

        var hasWidget = false;
        //check for any dojo widgets in the row
        if ((typeof(dijit) != 'undefined') && (typeof(dijit.findWidgets) == 'function') && (dijit.findWidgets(rowToAdjust).length > 0))
        {
            //loop through each cell to check which contains a widget
            for (var i = 0; i < rowToAdjust.cells.length; ++i)
            {
                var cellToAdjust = rowToAdjust.cells[i];

                //check for any dojo widgets in the cell
                if (dijit.findWidgets(cellToAdjust).length > 0)
                {
                    //revert widget to HTML
                    var currentValue = hyf.editabletable.getCellValue(cellToAdjust, 'data');
                    //Destroy any dojo widgets in the row being inserted before processing
                    hyf.util.destroyDojoWidgets(cellToAdjust);

                    //find the edit span and adjust the HTML
                    var editSpan = document.getElementById(rowToAdjust.id + i + hyf.editabletable.EDIT_ID_END);
                    var editHTML = document.getElementById(rowToAdjust.id + i + hyf.editabletable.HTML_CONTENT_ID_END);
                    editSpan.innerHTML = editHTML.value;

                    //update value in the new HTML
                    hyf.editabletable.setCellValue(cellToAdjust, currentValue);
                    hasWidget = true;
                }
            }
        }

        //hyf.editabletable.changeIds(rowToAdjust, currentId, newId);

        //change all row binding xpaths to reduce position number
        var spans = rowToAdjust.getElementsByTagName('span');
        for (var i = 0; i < spans.length; ++i)
        {
            var spanId = spans[i].getAttribute('id');
            if ((spanId != null) && (spanId.lastIndexOf(hyf.editabletable.DISPLAY_ID_END) + hyf.editabletable.DISPLAY_ID_END.length == spanId.length))
            {
                var fieldId = spanId.substring(0, spanId.length - hyf.editabletable.DISPLAY_ID_END.length);
                var editSpan = document.getElementById(fieldId + hyf.editabletable.EDIT_ID_END);

                editabletableProcessXPath(table, editSpan, ((rowToAdjust == topRow) ? 'INCREASE' : 'DECREASE'))

                //update the hidden field storing the edit HTML so that it will include the new xpath values
                var contentHidden = document.getElementById(fieldId + hyf.editabletable.HTML_CONTENT_ID_END);
                contentHidden.value = editSpan.innerHTML;
            }
        }

        hyf.editabletable.changeIds(rowToAdjust, currentId, newId);

        //reparse any dojo widgets if needed
        if (hasWidget)
        {
            dojo.parser.parse(rowToAdjust);
        }
    }
}



editabletableProcessXPath = function(table, container, predicateValue)
{
    var inputs = container.getElementsByTagName('input');
    for (var i = 0; i < inputs.length; ++i)
    {
        if (inputs[i].type == 'hidden')
        {
            /*if ((inputs[i].name == (fieldID + '_xpath')) ||
                (inputs[i].name.indexOf('xgf_' + fieldID + '_xpath') == 0))*/
            if (inputs[i].name.lastIndexOf('_xpath') == inputs[i].name.length - 6)
            {
                inputs[i].value = editabletableProcessXPathString(table, inputs[i].value, predicateValue, null);
            }
            else if ((inputs[i].name.lastIndexOf('_xpath') == inputs[i].name.length - 6) ||
                (inputs[i].name.indexOf('xgf_') == 0 && inputs[i].name.indexOf('_xpath_') != -1))
            {
                inputs[i].value = editabletableProcessXPathString(table, inputs[i].value, predicateValue, inputs[i].name.substr(inputs[i].name.lastIndexOf('_xpath_') + 6));
            }
        }
    }
}

editabletableProcessXPathString = function(table, xpathString, predicateValue, action)
{
    //find the context xpath for the repeat
    var contextXPath;
    var possibleContexts = table.parentNode.getElementsByTagName('input');
    for (var i = 0; i< possibleContexts.length; ++i)
    {
        if ((possibleContexts[i].type == 'hidden') &&
            (possibleContexts[i].name.indexOf('hyfrepeat-') == 0) &&
            (possibleContexts[i].name.lastIndexOf('-location') + 9 == possibleContexts[i].name.length) &&
            (action == null))
        {
            //is the context field
            contextXPath = possibleContexts[i].value;
            break;
        }
        else if ((possibleContexts[i].type == 'hidden') &&
            (possibleContexts[i].name.indexOf('xgf_hyfrepeat-') == 0) &&
            (possibleContexts[i].name.lastIndexOf('-location' + action) + (action.length) + 9 == possibleContexts[i].name.length) &&
            (action != null))
        {
            //is the context field
            contextXPath = possibleContexts[i].value;
            break;
        }
    }

    var newXPath = xpathString;

    //can only adjust if xpath starts with context
    if (xpathString.indexOf(contextXPath) == 0)
    {
        var remainder = xpathString.substring(contextXPath.length);
        if (remainder.indexOf('[') == 0)
        {
            var closingIndex = remainder.indexOf(']');

            if ((typeof(predicateValue) == 'undefined') || (predicateValue == 'DECREASE'))
            {
                var number = remainder.substring(1, closingIndex);
                number = parseInt(number) - 1;

                newXPath = contextXPath + '[' + number + remainder.substring(closingIndex);
            }
            else if (predicateValue == 'INCREASE')
            {
                var number = remainder.substring(1, closingIndex);
                number = parseInt(number) + 1;
                newXPath = contextXPath + '[' + number + remainder.substring(closingIndex);
            }
            else
            {
                newXPath = contextXPath + '[' + predicateValue + remainder.substring(closingIndex);
            }
        }
    }

    return newXPath;
}